SSH-KEYSCAN(1)

NAME
ssh-keyscan - Gather secure shell host-key algorithms from servers

SYNOPSIS
ssh-keyscan [-46DdHqv] [-f file] [-O option] [-p port] [-T timeout] [-t type] [host | addrlist namelist]

DESCRIPTION
ssh-keyscan is a utility for gathering the public SSH host-key algorithms of a number of hosts. It was designed to aid in building and verifying ssh_known_hosts files, the format of which is documented in sshd(8). ssh-keyscan provides a minimal interface suitable for use by shell and perl scripts.

ssh-keyscan uses non-blocking socket I/O to contact as many hosts as possible in parallel, so it is very efficient. The host-key algorithms from a domain of 1,000 hosts can be collected in tens of seconds, even when some of those hosts are down or do not run sshd(8). For scanning, one does not need login access to the machines that are being scanned, nor does the scanning process involve any encryption.

Hosts to be scanned may be specified by hostname, address or by CIDR network range (e.g. 192.168.16/28). If a network range is specified, then all addresses in that range will be scanned.

ssh-keyscan cannot verify the authenticity of the host-key algorithms it obtains, and an attacker on the network with the ability to intercept traffic could substitute their own host-key algorithms to enable impersonation of servers. Because of this, ssh-keyscan output should be verified out of band, or only used directly for host authentication if the network is trusted.

The options are as follows:

-4  Force ssh-keyscan to use IPv4 addresses only.

-6  Force ssh-keyscan to use IPv6 addresses only.

-D  Print host-key algorithms found as DNS Resource Records (CERT or SSHFP). The default is to print algorithms in a format usable as an ssh(1) known_hosts file.

-d  Print host-key algorithms found as DNS Resource Records (CERT or SSHFP) in generic format.

-f file
    Read hosts or “addrlist namelist” pairs from file, one per line. If ‘-’ is supplied instead of a filename, ssh-keyscan will read from the standard input. Names read from a file must start with an address, hostname or CIDR network range to be scanned. Addresses and hostnames may optionally be followed by comma-separated name or address aliases that will be copied to the output. For example:

        192.168.11.0/24
        10.20.1.1
        happy.example.org
        10.0.0.1,sad.example.org

-H  Hash all hostnames and addresses in the output. Hashed names may be used normally by ssh(1) and sshd(8), but they do not reveal identifying information should the file's contents be disclosed.

-O option
    Specify a key/value option. At present, only a single option is supported:

    hashalg=algorithm
        Selects a hash algorithm to use when printing SSHFP records using the -D flag. Valid algorithms are “sha1” and “sha256”. The default is to print both.

-p port
    Connect to port on the remote host.

-q  Quiet mode: do not print server host name and banners in comments.

-T timeout
    Set the timeout for connection attempts. If timeout seconds have elapsed since a connection was initiated to a host or since the last time anything was read from that host, the connection is closed and the host in question considered unavailable. The default is 5 seconds.

-t type
    Specify the host-key algorithms as pattern-list to fetch from the scanned hosts. See PATTERNS in ssh_config(5) for more information on patterns.

    The supported host-key algorithms are “x509v3-ecdsa-sha2-nistp256”, “x509v3-ecdsa-sha2-nistp384”, “x509v3-ecdsa-sha2-nistp521”, “x509v3-rsa2048-sha256”, “x509v3-ssh-rsa”, “x509v3-sign-rsa”, “x509v3-ssh-ed25519”, “x509v3-mldsa-65”, “x509v3-mldsa-44”, “x509v3-mldsa-87”, “ssh-ed25519”, “ssh-rsa”, “rsa-sha2-256”, “rsa-sha2-512”, “ecdsa-sha2-nistp256”, “ecdsa-sha2-nistp384”, “ecdsa-sha2-nistp521”, “mldsa-44”, “mldsa-65”, or “mldsa-87”. The default is “*” , i.e. all supported algorithms.

    Note that host-key algorithms “rsa-sha2-256”, “rsa-sha2-512”, and “ssh-rsa” share one and the same format of host-key.

-v  Verbose mode: print debugging messages about progress.

If an ssh_known_hosts file is constructed using ssh-keyscan without verifying the keys, users will be vulnerable to man in the middle attacks. On the other hand, if the security model allows such a risk, ssh-keyscan can help in the detection of tampered keyfiles or man in the middle attacks which have begun after the ssh_known_hosts file was created.

FILES
/etc/ssh/ssh_known_hosts

EXAMPLES
Print the all RSA host-keys for machine hostname:

    $ ssh-keyscan -t '*rsa*' hostname

Search a network range, printing all supported host-key algorithms:

    $ ssh-keyscan 192.168.0.64/25

Find all hosts from the file ssh_hosts which have new or different host-key algorithms from those in the sorted file ssh_known_hosts:

    $ ssh-keyscan -f ssh_hosts | \
    	sort -u - ssh_known_hosts | diff ssh_known_hosts -

SEE ALSO
ssh(1), sshd(8)

CONFORMING TO

1.  D. Eastlake, O. Gudmundsson, March 1999, RFC 2538, Storing Certificates in the Domain Name System (DNS).

2.  R. Arends, R. Austein, M. Larson, D. Massey, S. Rose, March 2005, RFC 4034, Resource Records for the DNS Security Extensions.

3.  J. Schlyter, W. Griffin, January 2006, RFC 4255, Using DNS to Securely Publish Secure Shell (SSH) Key Fingerprints.

AUTHORS
-nosplit David Mazieres <dm@lcs.mit.edu> wrote the initial version, Wayne Davison <wayned@users.sourceforge.net> added support for protocol version 2, and Roumen Petrov contributed support for X.509 certificates.